#include <stdio.h>
#include <stdlib.h>

#include "error.h"
#include "cdb.h"

int power_of( int x, int y ) {
	int return_val = x, i;

	for( i=0 ; i<y ; i++ ) {
		return_val = return_val * x;
	}
	return( return_val );
}

int main( int argc, char *argv[] ) {
	struct cdb c;
	FILE *fp;
	char file_name[1024], *ptr;
	int i, k;
	unsigned int j = 0;
	int p[4] = { 81, 110, 242, 129 };
	
	strcpy( file_name, "ipv4.cdb" );

	fp = fopen( file_name, "r+" );
	if( !fp ) { 
		perror( "Cannot open because" );
		return( EXIT_FAILURE );
	}

	cdb_init( &c, fileno( fp ) );
	cdb_findstart(&c);

	for( i = 0 ; i<4 ; i++ ) {
		j |= p[i] << (3-i)*8;
	}
	
	for( i = 0 ; i<4 ; i++ ) {
		printf( "%d\n", ( j >> ((3-i)*8) & 0xff ) );
	}
	
	/*
	 * j = 80 << 24 | 110 << 16 | 242 << 8 | 129;
	 */

	printf( "J: %ld\n", j );

	for( k = 0 ; k < 32 ; k++ ) {
		int base = power_of( 2, k );
		
		unsigned int l = j & ~( base - 1 );
		
		/*i = cdb_seek( &c, &l, sizeof( int ) );
		if( i == 0 ) {
			if( c.dpos ) {
				printf( "%s\n", c.dpos );
			}
			printf( "True\n" );
		}
		*/

		snprintf( file_name, 1024, "%u", l );
		/*
		 * snprintf( file_name, 1024, "1342177280" );
		 */

		i = cdb_find( &c, file_name, strlen( file_name ) );

		printf( "+ Key: %s (%d) [%d] {%u} -%u-\n", file_name, strlen( file_name ), i, base, l );

		if( i == 0 ) {
			continue;
		}

		if( i == -1 ) {
			printf( "Error reading cdb\n" );
			cdb_free( &c );
			return( EXIT_FAILURE );
		}

		p[0] = cdb_datapos( &c );
		p[1] = cdb_datalen( &c );
		if( cdb_read( &c, file_name, 1024, p[0] ) == -1 ) {
			printf( "cannot read\n" );
			continue;
		}

		ptr = file_name;
		while( 1 == 1 ) {
			printf( "%s\n", ptr );

			ptr += strlen( ptr ) + 1;
			
			if( ptr > file_name + p[1] ) {
				break;
			}
		}
		break;

	}

	cdb_free( &c );
}

